/*
 *  This file is part of M-Index library: http://disa.fi.muni.cz/m-index/
 *
 *  M-Index library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  M-Index library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with M-Index library.  If not, see <http://www.gnu.org/licenses/>.
 */
package mindex.distance;

import messif.algorithms.AlgorithmMethodException;
import messif.objects.LocalAbstractObject;
import mindex.MetricIndex;


@Deprecated
public class MaxHyperplaneDistCalculator extends HyperplaneDistCalculator {

    private final int firstQueryIndex;
    private final float firstQueryDist;
    
    public MaxHyperplaneDistCalculator(LocalAbstractObject queryObject, MetricIndex mIndex) throws AlgorithmMethodException {
        super(queryObject, mIndex);
        firstQueryIndex = queryPP[0];
        firstQueryDist = queryPivotDistances[queryPP[0]];
    }

    @Override
    public float getQueryDistance(short[] ppp) {        
        float max = 0f;
        for (int i = 0; i < getMaxLevel(ppp.length); i++) {
            float dist = queryPivotDistances[ppp[i]] - firstQueryDist;
            if (dist > 0f) {
                dist = 0.5f * dist * (queryPivotDistances[ppp[i]] + firstQueryDist) 
                        / mIndex.getPivotsDistance(ppp[i], firstQueryIndex);
            }
            max = max > dist ? max : dist;
        }
        return max;
    }
    
}
